import cpp
import semmle.code.cpp.security.FlowSources
import semmle.code.cpp.rangeanalysis.SimpleRangeAnalysis
import semmle.code.cpp.valuenumbering.GlobalValueNumbering

class EFIVarFunction extends Function {
  EFIVarFunction() {
    this.hasGlobalOrStdOrBslName("SmmSetVariable") or
    this.hasGlobalOrStdOrBslName("SmmGetVariable")
  }
}

class EFIVarPtrFunction extends PointerFieldAccess {
  EFIVarPtrFunction() {
    this.getTarget().hasName("SmmSetVariable") or
    this.getTarget().hasName("SmmGetVariable")
  }
}

predicate callHandlesEFIVariable(Expr e, Call c) {
  exists(Call x, PointerFieldAccess fa |
    // in case it is just a normal function call
    x.getParent() = e and x.getTarget() instanceof EFIVarFunction
    or
    // in case the function call is actually a pointer field access, the function name will be the name of the field itself
    c = x and
    c instanceof VariableCall and
    fa instanceof EFIVarPtrFunction and
    x.getParent() = e and
    c.(VariableCall).getVariable() = fa.getTarget()
  )
}

class EFIVar extends Variable {
  EFIVar() { exists(Expr e | callHandlesEFIVariable(e, _) and e.(Access).getTarget() = this) }
}

from Expr e, Call c, Variable v
where
  callHandlesEFIVariable(e, c) and
  e.(Access).getTarget() = v
select v, "This expression uses EFI variables"
